varying vec3 v_v3LightDir;
varying vec3 v_v3ViewDir;
varying vec3 v_v3Position;
uniform sampler2D u_s2Texture;
uniform sampler2D u_s2Normal;
uniform sampler2D u_s2Specular;


void main()
{
	// calculate diffuse-strength
	vec3 v3MathLightDir = normalize(v_v3LightDir);
	vec3 v3BumpNormal   = normalize((texture2D(u_s2Normal, gl_TexCoord[0].st).xyz * 2.0f) - 1.0f);
	float fBumpFactor   = dot(v3MathLightDir, v3BumpNormal); 
	
	// calculate specular-strength
	vec3 v3MathViewDir = normalize(v_v3ViewDir);
	vec3 v3ReflNormal  = normalize(((2.0f * v3BumpNormal) * fBumpFactor) - v3MathLightDir); 
	float fReflFactor  = max(0.0f, dot(v3MathViewDir, v3ReflNormal));
	
	// calculate color-values
	vec4 v4Color		 = texture2D(u_s2Texture, gl_TexCoord[0].st);
	vec4 v4FinalDiffuse  = 1.0f * v4Color * max(0.0f, (2.0+fBumpFactor)*0.35f);
	vec4 v4FinalSpecular = 0.3f * texture2D(u_s2Specular, gl_TexCoord[0].st) * pow(fReflFactor, 25.0f);
	vec4 v4FinalAmbient  = 0.1f * v4Color; 

	// set final color-value
	gl_FragColor   = v4FinalDiffuse + v4FinalSpecular + v4FinalAmbient;
	gl_FragColor.a = v4Color.a * (1.0f - max(0.0f, (length(v_v3Position)-62.0f)/5.0f));
}