varying vec3 v_v3LightDir;
varying vec3 v_v3ViewDir;
varying vec3 v_v3Position;
attribute vec3 a_vTangent;
	
	
void main()
{
	// transform and calculate normal, tangent and binormal
	vec3 n = normalize(gl_NormalMatrix * gl_Normal);
	vec3 t = normalize(gl_NormalMatrix * a_vTangent);
	vec3 b = cross(n, t);

	// transform vertexposition and lightdirection
	gl_ClipVertex     = gl_ModelViewMatrix * gl_Vertex;
	vec3 MathPosition = gl_ClipVertex.xyz;
	vec3 MathLightDir = gl_LightSource[0].position.xyz;
	v_v3Position      = MathPosition;

	// dot3-transform the lightdirection
	v_v3LightDir.x = dot(MathLightDir, t);
	v_v3LightDir.y = dot(MathLightDir, b);
	v_v3LightDir.z = dot(MathLightDir, n);
	v_v3LightDir   = normalize(v_v3LightDir);

	// dot3-transform the viewdirection
	v_v3ViewDir.x = dot(MathPosition, t);
	v_v3ViewDir.y = dot(MathPosition, b);
	v_v3ViewDir.z = dot(MathPosition, n);
	v_v3ViewDir   = normalize(v_v3ViewDir);

	// fixed vertex and texture transformations
	gl_Position    = ftransform();
	gl_TexCoord[0] = gl_MultiTexCoord0;
} 